      SUBROUTINE QS21R(U,V,A,B,F,N,IERR)                                QS210010
         INTEGER IERR,N                                                 QS210020
         REAL A,B,U,V                                                   QS210030
         DIMENSION U(N),V(N)                                            QS210040
         EXTERNAL F,FTF1C                                               QS210050
         INTEGER IN,K,KK,N1,N2,NMAX                                     QS210060
         REAL D,D1,F1,F2,P,R1,R2,X                                      QS210070
         DATA NMAX/1048576/                                             QS210080
       IERR = 0                                                         QS210090
       IF (N .EQ. 0) GO TO 70                                           QS210100
          IF (N .LE. NMAX) GO TO 10                                     QS210110
             IERR = 65                                                  QS210120
             CALL UTQS10(IERR,17)                                       QS210130
             GO TO 70                                                   QS210140
   10  CONTINUE                                                         QS210150
       D = B - A                                                        QS210160
       D1 = D/N                                                         QS210170
       IN = 1                                                           QS210180
       KK = 1                                                           QS210190
       P = 1.                                                           QS210200
       N1 = N/2                                                         QS210210
       N2 = N1 - 1                                                      QS210220
       DO 20 K = 1, N                                                   QS210230
          X = A + (K - 1)*D1                                            QS210240
          CALL F(X,F1,F2)                                               QS210250
          U(K) = F1                                                     QS210260
          V(K) = F2                                                     QS210270
   20  CONTINUE                                                         QS210280
       U(1) = U(1)/3.                                                   QS210290
       V(1) = V(1)/3.                                                   QS210300
       DO 30 K = 1, N1                                                  QS210310
          U(2*K) = 4.*U(2*K)/3.                                         QS210320
          V(2*K) = 4.*V(2*K)/3.                                         QS210330
   30  CONTINUE                                                         QS210340
       DO 40 K = 1, N2                                                  QS210350
          U(2*K+1) = 2.*U(2*K+1)/3.                                     QS210360
          V(2*K+1) = 2.*V(2*K+1)/3.                                     QS210370
   40  CONTINUE                                                         QS210380
       CALL FTF1C(U,V,N,IN,KK,P)                                        QS210390
       DO 50 K = 1, N                                                   QS210400
          U(K) = D1*U(K)                                                QS210410
          V(K) = D1*V(K)                                                QS210420
   50  CONTINUE                                                         QS210430
       CALL F(B,F1,F2)                                                  QS210440
       R1 = F1/(3.*N)                                                   QS210450
       R2 = F2/(3.*N)                                                   QS210460
       DO 60 K = 1, N                                                   QS210470
          U(K) = U(K) + R1                                              QS210480
          V(K) = V(K) + R2                                              QS210490
   60  CONTINUE                                                         QS210500
   70  RETURN                                                           QS210510
      END                                                               QS210520
